
/*
 * TYPEDEFS.H
 */

#ifndef MYLIB_TYPEDEFS_H
#define MYLIB_TYPEDEFS_H
#ifdef INTUITION_INTUITION_H

typedef struct BitMap	    BITMAP;
typedef struct BoolInfo     BOOLINFO;
typedef struct Border	    BORDER;
typedef struct Gadget	    GADGET;
typedef struct Image	    IMAGE;
typedef struct IntuiMessage INTUIMESSAGE;
typedef struct IntuiMessage IMESS;
typedef struct IntuiText    INTUITEXT;
typedef struct IntuiText    ITEXT;
typedef struct Menu	    MENU;
typedef struct MenuItem     MENUITEM;
typedef struct MenuItem     ITEM;
typedef struct NewScreen    NEWSCREEN;
typedef struct NewScreen    NS;
typedef struct NewWindow    NEWWINDOW;
typedef struct NewWindow    NW;
typedef struct Preferences  PREFERENCES;
typedef struct Preferences  PREFS;
typedef struct PropInfo     PROPINFO;
typedef struct RastPort     RASTPORT;
typedef struct RastPort     RP;
typedef struct Remember     REMEMBER;
typedef struct Requester    REQUESTER;
typedef struct Screen	    SCR;
typedef struct StringInfo   STRINGINFO;
typedef struct Window	    WINDOW;
typedef struct Window	    WIN;

#endif

#ifdef INTUITION_INTUITIONBASE_H

typedef struct GListEnv 	GLISTENV;
typedef struct GadgetInfo	GADGETINFO;
typedef struct IBox		IBOX;
typedef struct IntuitionBase	INTUITIONBASE;
typedef struct IntuitionBase	IBASE;
typedef struct PenPair		PENPAIR;
typedef struct Point		POINT;

#endif

#ifdef DEVICES_AUDIO_H

typedef struct IOAudio		IOAUDIO;
typedef struct IOAudio		IOA;

#endif

#ifdef DEVICES_BOOTBLOCK_H

typedef struct BootBlock	BOOTBLOCK;

#endif

#ifdef DEVICES_CLIPBOARD_H

typedef struct IOClipReq	IOCLIPREQ;
typedef struct IOClipReq	IOCL;
typedef struct ClipboardUnitPartial CLIPUNIT;
typedef struct SatisfyMsg	SATISFYMSG;

#endif

#ifdef DEVICES_CONUNIT_H

typedef struct ConUnit	    CONUNIT;
typedef struct IOStdReq     IOCON;

#endif

#ifdef DEVICES_INPUTEVENT_H

typedef struct InputEvent   INPUTEVENT;
typedef struct InputEvent   IE;

#endif

#ifdef GRAPHICS_TEXT_H

typedef struct TextAttr TA;
typedef struct TextFont FONT;

#endif

#ifdef GRAPHICS_GELS_H

typedef struct VSprite	VS;
typedef struct Bob	BOB;
typedef struct AnimComp ANIMCOMP;
typedef struct AnimOb	ANIMOB;

#endif

#ifdef GRAPHICS_RASTPORT_H

typedef struct GelsInfo GELSINFO;

#endif

#ifdef GRAPHICS_VIEW_H

typedef struct ViewPort VP;

#endif

#ifdef LIBRARIES_DOS_H

typedef struct Process		PROC;
typedef struct Task		TASK;
typedef struct FileInfoBlock	FIB;

#endif

#ifdef DEVICES_TIMER_H

typedef struct timeval		TV;
typedef struct timerequest	TIMER;

#endif

#endif


